/*
 * Main.java
 *
 * Created on May 21, 2007, 6:15 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/*
 * Features to add:
 * Importing maps/tiles from/to bitmaps
 * Tiles internalFrame, drag and drop onto map
 * Can also draw directly on map
 * Generate 68k C, 68k C (ExtGraph(, 68k ASM, and Z80 ASM code
 */

package cme;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

/**
 *
 * @author Owner
 */

public class Main extends JFrame implements ActionListener, ItemListener {
    
    JInternalFrame drawingframe;
    JDesktopPane desk;
    JPanel drawingpanel = new JPanel();
    JInternalFrame tilesframe;
    JPanel tilespanel = new JPanel();
    JPanel mappanel = new JPanel();
    JInternalFrame mapframe;
    JMenuBar menubar = new JMenuBar();
    JMenu filemenu = new JMenu("File");
    JMenu editmenu = new JMenu("Edit");
    JMenu mapmenu = new JMenu("Map");
    JMenu tilesmenu = new JMenu("Tiles");
    JMenu toolsmenu = new JMenu("Tools");
    JMenu windowmenu = new JMenu("Window");
    JMenu aboutmenu = new JMenu("Help");
    JMenuItem fileItem1 = new JMenuItem("New Map...");
    JMenuItem fileItem2 = new JMenuItem("New Tileset...");
    JMenuItem fileItem3 = new JMenuItem("Open Map...");
    JMenuItem fileItem4 = new JMenuItem("Open Tileset...");
    JMenuItem fileItem5 = new JMenuItem("Save");
    JMenuItem fileItem6 = new JMenuItem("Save As...");
    JMenuItem fileItem7 = new JMenuItem("Exit");

    JMenuItem editItem1 = new JMenuItem("Undo");
    JMenuItem editItem2 = new JMenuItem("Redo");
    JMenuItem editItem3 = new JMenuItem("Cut");
    JMenuItem editItem4 = new JMenuItem("Copy");
    JMenuItem editItem5 = new JMenuItem("Paste");
    JMenuItem editItem6 = new JMenuItem("Select All");
    
    JMenuItem mapItem1 = new JMenuItem("Attributes...");
    JMenuItem mapItem2 = new JMenuItem("Import From Bitmap...");
    JMenuItem mapItem3 = new JMenuItem("Import From Code...");
    JMenuItem mapItem4 = new JMenuItem("Export As Bitmap...");
    JMenuItem mapItem5 = new JMenuItem("Export As Code...");
    
    JMenuItem tilesItem1 = new JMenuItem("Import From Tileset...");
    JMenuItem tilesItem2 = new JMenuItem("Import From Bitmap...");
    JMenuItem tilesItem3 = new JMenuItem("Import From Code...");
    JMenuItem tilesItem4 = new JMenuItem("Export As Tileset...");
    JMenuItem tilesItem5 = new JMenuItem("Export As Bitmaps...");
    JMenuItem tilesItem6 = new JMenuItem("Export As Code...");
    
    JMenuItem toolsItem1 = new JMenuItem("Zoom...");    // A pop up asks containing "In" button, "out" button, or a "Specify Value" option with a textbox"
    JMenuItem toolsItem2 = new JMenuItem("Code...");    // Generate sample C/Extgraph/Z80 Jim E code
    
    JMenuItem windowItem1 = new JMenuItem("Drawing");
    JMenuItem windowItem2 = new JMenuItem("Map");
    JMenuItem windowItem3 = new JMenuItem("Tiles");
    
    JMenuItem helpItem1 = new JMenuItem("About");
    
    JButton drawingbutton1 = new JButton("Pencil");
    JButton drawingbutton2 = new JButton("Line");
    JButton drawingbutton3 = new JButton("Paint Pucket");
    JButton drawingbutton4 = new JButton("Recntangle");
    JButton drawingbutton5 = new JButton("Filled Rectangle");
    
    
    
    Image mapbuffer;
    Graphics mbuff; // interface for buffer drawing
    
    /** Creates a new instance of Main */
    public Main() {
        this.setTitle("Cross-platform Map Editor");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        fileItem1.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
        fileItem1.addActionListener(this);
        
        fileItem3.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
        fileItem3.addActionListener(this);
        
        fileItem5.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
        fileItem5.addActionListener(this);
        
        fileItem7.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E, ActionEvent.CTRL_MASK));
        fileItem7.addActionListener(this);
        
        filemenu.add(fileItem1);
        filemenu.add(fileItem2);
        filemenu.add(fileItem3);
        filemenu.add(fileItem4);
        filemenu.add(fileItem5);
        filemenu.add(fileItem6);
        filemenu.add(fileItem7);
        
        editmenu.add(editItem1);
        editmenu.add(editItem2);
        editItem3.add(new JSeparator());
        editmenu.add(editItem3);
        editmenu.add(editItem4);
        editmenu.add(editItem5);
        editItem6.add(new JSeparator());
        editmenu.add(editItem6);
        
        mapmenu.add(mapItem1);
        mapItem2.add(new JSeparator());
        mapmenu.add(mapItem2);
        mapmenu.add(mapItem3);
        mapItem4.add(new JSeparator());
        mapmenu.add(mapItem4);
        mapmenu.add(mapItem5);
        
        tilesmenu.add(tilesItem1);
        tilesmenu.add(tilesItem2);
        tilesmenu.add(tilesItem3);
        tilesItem4.add(new JSeparator());
        tilesmenu.add(tilesItem4);
        tilesmenu.add(tilesItem5);
        tilesmenu.add(tilesItem6);
        
        toolsmenu.add(toolsItem1);
        toolsmenu.add(toolsItem2);
        
        windowmenu.add(windowItem1);
        windowmenu.add(windowItem2);
        windowmenu.add(windowItem3);
        windowItem1.addActionListener(this);
        windowItem2.addActionListener(this);
        windowItem3.addActionListener(this);
        
        aboutmenu.add(helpItem1);
        helpItem1.addActionListener(this);
        
        menubar.add(filemenu);
        menubar.add(editmenu);
        menubar.add(mapmenu);
        menubar.add(tilesmenu);
        menubar.add(toolsmenu);
        menubar.add(windowmenu);
        menubar.add(aboutmenu);
        this.setJMenuBar(menubar);
        
        drawingpanel.add(drawingbutton1);
        drawingpanel.add(drawingbutton2);
        drawingpanel.add(drawingbutton3);
        drawingpanel.add(drawingbutton4);
        drawingpanel.add(drawingbutton5);
        drawingframe = new JInternalFrame("Drawing", true,true,true,true);
        drawingframe.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
        drawingframe.add(drawingpanel);
        drawingframe.setSize(155,300);
        drawingframe.setVisible(true);
        
        tilesframe = new JInternalFrame("Tiles", true,true,true,true);
        tilesframe.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
        tilesframe.add(tilespanel);
        tilesframe.setSize(135,500);
        tilesframe.setLocation(675,0);
        //tilesframe.setAlignmentX
        tilesframe.setVisible(true);
        
        mapframe = new JInternalFrame("Map - Zoom: x2, Size: 96x64, Mode: Grayscale", true,true,true,true);
        mapframe.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
        mapframe.add(mappanel);
        mapframe.setLocation(160,0);
        mapframe.setSize(500,500);
        MapData mdata = new MapData();
        mapframe.getContentPane().add(mdata);
        mapframe.setVisible(true);
        
        desk = new JDesktopPane();
        desk.add(drawingframe);
        desk.add(tilesframe);
        desk.add(mapframe);
        this.add(desk);
        this.setSize(850,600);
        this.setVisible(true);
        
    try
    {
      mapbuffer = createImage(192, 128);
      mbuff = mapbuffer.getGraphics();
    }
    catch (Exception e)
    {
      JOptionPane.showMessageDialog(this,"Failed to set up hidden buffer","Error",1);
      mapbuffer = null;
      mbuff = null;
      dispose();
      System.exit(0);
    }
    
        
      mbuff.setColor(Color.white);
      mbuff.fillRect(5,5,192,128);
      
    }
        
    
    public void actionPerformed(ActionEvent e) {
        if(e.getSource()==fileItem1){
            
        }
        else if(e.getSource()==fileItem7){
            dispose();
            System.exit(0);
        }
        else if(e.getSource()==windowItem1){
            drawingframe.setVisible(true);
        }
        else if(e.getSource()==windowItem2){
            mapframe.setVisible(true);
        }
        else if(e.getSource()==windowItem3){
            tilesframe.setVisible(true);
        }
        else if(e.getSource()==helpItem1){
            JOptionPane.showMessageDialog(this,"Cross-platform Map Editor 0.1 \nWritten In Java for JRE 1.5.0_11 \nby bfr - http://bfr.tifreakware.net","About",1);
        }
            
    }
    
    public void itemStateChanged(ItemEvent e) {

    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
       Main Mainobject = new Main();
    }
    
public class MapData extends JComponent{
    public void paint(Graphics g){
      
      //int height = 200;
      //int width = 120;
      /*
      g.setColor(Color.red);
      g.drawRect(10,10,height,width);
      g.setColor(Color.gray);
      g.fillRect(11,11,height,width); 
      g.setColor(Color.red);
      g.drawOval(250,20, height,width);
      */
      //g.setColor(Color.magenta);
      //g.fillOval(249,19,height,width); 
       
      g.drawImage(mapbuffer, 0, 0, this); 
    }
  }
   public void update(Graphics g)
  {
    paint(g);
  }
    
}

/*  TODO:
 *  
 *  - Tilesets
 *
 *
 */


